<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Modulos</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Modulo?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <draggable
          v-model="modulos"
          v-bind="{ group: 'people', draggable: '.item' }"
          style="min-height: 10px"
          class="row"
        >
          <template v-for="(modulo, indexModulo) in modulos">
            <v-col
              class="item"
              :key="indexModulo"
              :xs="12"
              :sm="12"
              :md="6"
              :lg="3"
            >
              <div>
                <v-card class="generalCard pa-4">
                  <div>
                    <v-btn
                      x-small
                      class="float-left"
                      text
                      icon
                      @click="(dialogDelete = true), (modulo_delete = modulo)"
                    >
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/delete.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                    <v-btn
                      :to="modulo.to"
                      x-small
                      class="float-right"
                      text
                      icon
                    >
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/icoEditar.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                  </div>
                  <v-card-text>
                    <div class="cardFranqName cardFranqNameLine">
                      {{ modulo.descripcion }}
                    </div>
                    <div class="cardCreacion">
                      <div>
                        Fecha de creación:
                        {{ moment(modulo.fecha_creacion).format("DD/MM/YYYY") }}
                      </div>
                    </div>
                    <v-footer absolute class="CardCustomAction">
                      <v-col>
                        <v-btn
                          :to="modulo.to_submodulos"
                          class="ma-2"
                          dark
                          tile
                          depressed
                          color="primary"
                          >Gestionar Submodulos</v-btn
                        >
                      </v-col>
                    </v-footer>
                  </v-card-text>
                </v-card>
              </div>
            </v-col>
          </template>
        </draggable>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddModulo.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddModulo.to"
            :color="cardAddModulo.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddModulo.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddModulo.src"
                :lazy-src="cardAddModulo.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este modulo?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingModulo }]"
                  @click="deleteModulo()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
import draggable from "vuedraggable";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-Modulos",
  components: {
    draggable
  },
  data() {
    return {
      moment: moment,
      modulo_delete: null,
      dialogDelete: false,
      flujoParent: null,
      deletingModulo: false,
      cardAddModulo: {
        title: "Crear Modulo",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo modulo a la lista.",
        to: {
          name: "privilegios_flujos_modulos_nuevo"
        },
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Flujos",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos"
          }
        }
      ],
      modulos: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    getModulos() {
      var self = this;
      let params;
      axios
        .post("/modulo/flujo/secure/get/flujo/parent", this.flujoParent)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setModulos(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setModulos(data) {
      if (data) {
        data.forEach((itemModulo) => {
          itemModulo.to = {
            name: "privilegios_flujos_modulos_edicion",
            params: {
              modulo: this.serviceCommons.objectToBase64(itemModulo)
            }
          };
          itemModulo.to_submodulos = {
            name: "privilegios_flujos_modulos_submodulos",
            params: {
              modulo: this.serviceCommons.objectToBase64(itemModulo),
              flujo: this.serviceCommons.objectToBase64(this.flujoParent)
            }
          };
        });
        this.modulos = data;
      }
    },
    deleteModulo() {
      var self = this;
      self.modulo_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/modulo/flujo/secure/delete", { data: self.modulo_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getModulos();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingModulo = false;
        });
    },
    initValues() {
      this.breadcrumbs.push({
        text: this.flujoParent.descripcion,
        disabled: true
      });
      this.breadcrumbs.push({
        text: "Modulos",
        disabled: true
      });
    },
    onCreated() {
      if (this.$route.params.flujo) {
        this.flujoParent = this.serviceCommons.base64ToObject(
          this.$route.params.flujo
        );
      }
      this.initValues();
      this.getModulos();
    }
  },
  created() {
    this.onCreated();
  }
};
</script>
